/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/MapContext.tsx
var MapContext_exports = {};
__export(MapContext_exports, {
  MapContextConsumer: () => MapContextConsumer,
  MapContextProvider: () => MapContextProvider,
  default: () => MapContext_default,
  testTileConfig: () => testTileConfig
});
module.exports = __toCommonJS(MapContext_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/MapContext.tsx
var MapContext = react_exports.createContext({ defaultTileConfig: [] });
MapContext.displayName = `data-splunk-visualization-version-MapContext-${"27.3.0 - bd2e687fd"}`;
var MapContextProvider = MapContext.Provider;
var MapContextConsumer = MapContext.Consumer;
var MapContext_default = MapContext;
var testTileConfig = [
  {
    name: "Carto Base Map - Light",
    key: "carto.base.map.light",
    theme: "light",
    sources: {
      "base-tiles": {
        type: "raster",
        tiles: ["https://a.basemaps.cartocdn.com/rastertiles/voyager_labels_under/{z}/{x}/{y}.png"],
        tileSize: 256
      }
    },
    layers: [
      {
        id: "base-layer",
        type: "raster",
        source: "base-tiles",
        minzoom: 0,
        maxzoom: 12,
        paint: {
          "raster-fade-duration": 0
        }
      }
    ]
  },
  {
    name: "Cart Base Map - dark",
    key: "carto.base.map.dark",
    theme: "dark",
    sources: {
      "base-tiles": {
        type: "raster",
        tiles: ["https://a.basemaps.cartocdn.com/rastertiles/dark_all/{z}/{x}/{y}.png"],
        tileSize: 256
      }
    },
    layers: [
      {
        id: "base-layer",
        type: "raster",
        source: "base-tiles",
        minzoom: 0,
        maxzoom: 12,
        paint: {
          "raster-fade-duration": 0
        }
      }
    ]
  }
];
//# sourceMappingURL=MapContext.js.map
